SimpleEvents plugin for GetSimple CMS
===========

Description
--------

SimpleEvents plugin is based on **I18N** plugin's hierarchical navigation (therefore it requires the I18N plugin to be active).

Plugin's management site is located in the side menu of **"Pages"** tab in GetSimple CMS admin panel.

After plugin's activation on the plugin's management site you have to choose the parent page for events from existing pages (on this page the events' list will be displayed, new events will become it's subpages). If the chosen page already has subpages, they will become events.

###Adding events###

Choose **"Add event"** link from the plugin's management site.

###Browsing events###

Choose **"Browse events"** link from the plugin's management site. The pages list will be displayed with events highlighted.

###Editing events###

Events can be edited in the **"Pages"** tab, in the same way as any other page.

###Deleting events###

Events can be deleted in the **"Pages"** tab, in the same way as any other page.

###Special fields: date, time, place###

Plugin adds the elements for adding data (input) for event's special fields on event's add/edit page (note: input elements for date and time are added only for events in default language, because in translations date and time remain the same). To unfold them you have to click the **"Page options"** button.

###Events list###

Events list is displayed on the events' parent page as unordered list (ul) of class "SimpleEvents". Every event in the list is displayed as follows:

`<li><span>[dates]</span><a href="[url]">[title]</a></li>`

Events are ordered from newest to oldest.

Past events are displayed below current events in the same form, additionally provided with class "SimpleEvents-past".

If no current events are found the content of the events' parent page is displayed (so you can put a paragraph informing about the lack of current events there).

###Events' pages###

On each event's page special fields' (date, time, location) values are displayed as header tags (h2) of class "date", "time" and "location" respectively above event's content.

###Plugin's deactivation###

After deactivating the SimpleEvents plugin you have to remove it's configuration file (data/other/simpleevents/config.php) and events' pages if necessary.


Requirements
--------

* Tested with GetSimple CMS version 3.3.*
* i18n plugin must be active


Installation
--------

Unzip the plugin's archive to the GS plugins directory. In the GS admin panel go to the **"Pages"** tab and choose **"Events"** from the sidebar. You'll be asked to choose a parent page for events (from existing pages).


License
--------

The SimpleEvents plugin's code is licensed under the GNU General Public License v3.
